%define	name	xinetd
%define	version	2.3.3
%define	release	1.0.19
%define	serial	5

Summary:	xinetd is a powerful replacement for inetd.
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Group:		System Environment/Daemons
Copyright:	BSD
Url:		http://www.xinetd.org
Vendor:		Rob Braun <bbraun@synack.net>
Source:		%{name}-%{version}.tar.gz
Source1:	xinetd.init
Source2:	xinetd.conf
Source3:	xinetd.log
Patch1:		xinetd-2.3.3-umask-and-off-by-one-gd.diff
Requires:	tcp_wrappers
Buildroot:	/var/tmp/%{name}-%{version}-root

%description
xinetd is a powerful replacement for inetd.
xinetd has access control machanisms, extensive logging capabilities,
the ability to make services available based on time, and can place
limits on the number of servers that can be started, among other things.

xinetd has the ability to redirect TCP streams to a remote host and
port. This is useful for those of that use ip masquerading, or NAT,
and want to be able to reach your internal hosts.

xinetd also has the ability to bind specific services to specific
interfaces. This is useful when you want to make services available
for your internal network, but not the rest of the world.  Or to have
a different service running on the same port, but different interfaces.

Built with the following configure option(s).
	--prefix=/usr,
	--with-libwrap,
	--with-loadavg

%prep
%setup -q
%patch1 -p1 -b .gd

CFLAGS="$RPM_OPT_FLAGS" CC="gcc" \
	./configure --prefix=%{_prefix} --mandir=%{_mandir} \
	--with-libwrap --with-loadavg


%build
make CFLAGS="$RPM_OPT_FLAGS"
cp -p libs/src/sio/README README-libsio
cp -p libs/src/str/README README-libstr
cp -p libs/src/misc/README README-libmisc


%install
[ -d $RPM_BUILD_ROOT ] && rm -r $RPM_BUILD_ROOT;
mkdir -p $RPM_BUILD_ROOT/usr/{sbin,lib/xinetd,include/xinetd,share/man/man3}
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d

install -m 700 %{SOURCE1} $RPM_BUILD_ROOT/etc/init.d/xinetd
install -m 640 %{SOURCE2} $RPM_BUILD_ROOT/etc/xinetd.conf
install -m 640 %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/xinetd

make PREFIX=$RPM_BUILD_ROOT/usr prefix=$RPM_BUILD_ROOT/usr install
strip $RPM_BUILD_ROOT/usr/sbin/xinetd

make LIBDIR=$RPM_BUILD_ROOT/usr/lib/xinetd \
     INCLUDEDIR=$RPM_BUILD_ROOT/usr/include/xinetd \
     MANDIR=$RPM_BUILD_ROOT%{_mandir}/man3 makelibs

%clean
[ -d $RPM_BUILD_ROOT ] && rm -r $RPM_BUILD_ROOT;


%post
if [ -f /var/lock/subsys/xinetd ]; then
	/etc/init.d/xinetd restart || 1;
fi


%files
%defattr(0444,root,root)
%doc INSTALL README xinetd/CHANGELOG xinetd/COPYRIGHT xinetd/sample.conf
%doc %{_mandir}/man3/*

%defattr(-,root,root)
%attr(0660,root,admin) %config /etc/xinetd.conf
%attr(0640,root,admin) %config /etc/logrotate.d/xinetd
%attr(0700,root,root) /etc/init.d/xinetd

%defattr(0750,root,admin)
/usr/sbin/itox
/usr/sbin/xinetd
%config /etc/xinetd.d


%changelog
* Fri Oct 12 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Version 2.3.3, Release 1.1.19
  - Removed %pre.  Added restart to %post.


* Thu Oct 11 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Version 2.3.3, Release 1.1.18
  - New upstream version.  Fixes more security-related bugs.
  - Removed the bounds-checking patch (it's now in the dist).  We still
    enforce our own umask and fix the off-by-one error in svc_logprint().


* Thu Jun 21 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.1.8.9pre16, Release 1.0.17
  - New upstream version.
  - Removed the USERID from xinetd.conf.  Ident is evil.
  - Added xinetd-2.1.8.9pre16-format-umask-gd.diff:
    - Adds (len <= 0) checks in libs/stc/str/strprint.c
    - Sets umask to 022 in all circumstances.
    - Fixes strx_nprintv in xinetd/log.c
    - Thanks to Wichert Akkerman (Debian) and Sebastian Krahmer (SuSE).


* Mon Jun 04 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.1.8.9pre15, Release 1.0.16
  - New upstream version fixes the "Bad address" bug (closes #00027)
  - This version also changes the umask from 0 to 022 (xinetd/init.c).
  - This version also fixes a format string bug (xinetd/log.c).


* Tue Apr 10 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.1.8.9pre14, Release 1.0.9
  - more... i386... build... fixes...


* Wed Mar 28 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.1.8.9pre14, Release 1.0.8
  - Removed from chkconfig so it's off by default.
  - Changed mode on initscript to 0700, root/root.


* Tue Mar 27 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Updated initscript.


* Wed Mar 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.1.8.9pre14, Release 1.0.6
  - Updated to latest version so we can use the 'includedir' directive.


* Wed Mar 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.1.8.8p3, Release 1.0.5
  - Updated config files to use /etc/xinetd.d.
  - %post no longer attempts to start xinetd.
  - %post now puts xinetd in runlevel 3 only.
  - Tweaked the %files listing a little bit.


* Tue Feb 13 2001 Pete 0'Hara <pete@guardiandigital.com>
- removed "rc.d" reference from /etc/init.d/xinetd

* Sun Nov 19 2000 Dave Wreski <dave@guardiandigital.com>
- FHS fixes
- permission changes

* Thu Nov 07 2000 Pete 0'Hara <pete@guardiandigital.com>
- moved /etc/rc.d/* to /etc

* Wed Jun 21 2000 Pete 0'Hara <pete@guardiandigital.com>
- removed xconv.pl
- created default xinetd.conf and xinetd.log file

* Tue Jun 20 2000 Pete O'Hara <pete@guardiandigital.com>
- remove old cruft
